package ru.dbotthepony.mc.otm.mixin;

import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.item.Item;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;
import ru.dbotthepony.mc.otm.registry.MCreativeTabsKt;

@Mixin(Item.class)
public abstract class ItemMixin {
	@Inject(
		at = @At("HEAD"),
		method = "getItemCategory()Lnet/minecraft/world/item/CreativeModeTab;",
		cancellable = true
	)
	public void getItemCategory$hook(CallbackInfoReturnable<CreativeModeTab> info) {
		if (MCreativeTabsKt.getMainTabContents().contains((Item) ((Object) this))) {
			info.setReturnValue(OverdriveThatMatters.INSTANCE.CREATIVE_TAB);
		} else if (MCreativeTabsKt.getDecorativeTabContents().contains((Item) ((Object) this))) {
			info.setReturnValue(OverdriveThatMatters.INSTANCE.CREATIVE_TAB_DECORATIVE);
		}
	}
}
